"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Render = exports.RenderBase = void 0;
var react_1 = __importDefault(require("react"));
var tiny_emitter_1 = require("tiny-emitter");
var rendererLegacy_1 = __importStar(require("./rendererLegacy"));
var isConnectedToDevTools = false;
exports.RenderBase = function (element) {
    if (!isConnectedToDevTools) {
        if (process.env.NODE_ENV === "development") {
            rendererLegacy_1.connectReactDevtools(rendererLegacy_1.default);
        }
    }
    else {
        isConnectedToDevTools = true;
    }
    return rendererLegacy_1.default.updateContainer(element, rendererLegacy_1.default.createContainer());
};
var RenderApp = function (props) {
    var _a = react_1.default.useState(false), isStoped = _a[0], setIsStoped = _a[1];
    react_1.default.useEffect(function () {
        props.emitter.on("stop", function () { return setIsStoped(true); });
        props.emitter.on("continue", function () { return setIsStoped(false); });
    }, []);
    return isStoped ? react_1.default.createElement(react_1.default.Fragment, null) : props.children;
};
exports.Render = function (element) {
    var emitter = new tiny_emitter_1.TinyEmitter();
    exports.RenderBase(react_1.default.createElement(RenderApp, { emitter: emitter }, element));
    return {
        stop: function () { return emitter.emit("stop"); },
        continue: function () { return emitter.emit("continue"); },
    };
};
